( Copyright{2004}: Albert van der Horst, HCC FIG Holland by GNU Public License)
( $Id: refilter.frt,v 1.1 1997/07/18 10:29:26 albert Exp albert $)

\ Regular expression filter script.
\ Start the command file with :   #!refilter -s
\ Make sure the current directory contains forth.lab.

INCLUDE streams.frt
INCLUDE regexp.frt
REQUIRE RESTORED
REQUIRE ARG[]

: REPLACEMENT 0 STRING-COPY !   RE-REPLACE>SC   STRING-COPY $@ ;

\ Contains a pointer to the regular expression.
\ (Those are not strings!)
VARIABLE re-exp
\ The string that contains the substitution expression.
CREATE subst$ 2 CELLS ALLOT

\ Into STRING substitute re STRING by substition STRING , just once.
\ Leave edited STRING.
: ONCE subst$ 2! RE-BUILD re-exp !
    !STREAM
    re-exp @ (RE-MATCH) BEFORE\0 >STREAM IF
       subst$ 2@ REPLACEMENT >STREAM
       AFTER\0 >STREAM
    THEN
    STREAM@
;
\ Into STRING substitute re STRING by substition STRING.
\ Repeat for the remainder after the match to the re string.
\ Leave edited STRING.
: GLOBAL subst$ 2! RE-BUILD re-exp !
    !STREAM
    BEGIN re-exp @ (RE-MATCH) BEFORE\0 >STREAM WHILE
       subst$ 2@ REPLACEMENT >STREAM
       AFTER\0
    REPEAT
    STREAM@
;

\ Load SCREEN unless it is screen 1.
\ We know it already has been loaded.
\ This prevents redefine messages when compiled program is used.
: LOAD  DUP 1 = IF DROP ELSE LOAD THEN ;

\ This leaves a program that can be used as a script.
\ It executes the same code as lina when called as a script.
\ If you use ``SAVE-SYSTEM'' you can leave this out, but you
\ end up with the sources occupying space in the saved system.
: MAIN   _ ^S LOAD ;
